#include "sm4_crypt.h"
#include "sshbuf.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int sm4_crypt(const SM4_KEY *sm4_ctx, const unsigned char *in,
			unsigned char *out, unsigned int len, unsigned int aadlen,
			int do_encrypt)
{
	int k = 0;
	int i = 0;
	long long real_len = 0;
	unsigned char tmp[16] = {0};
	unsigned char out_tmp[16] = {0};
	int header_len = 0;

	if (len <= aadlen)
		return -1;


	for (i = 0; i < (int)aadlen; i++) {
		out[i] = in[i];
		header_len++;
	}

	real_len = (long long)len;
	do {
		memset(tmp, 0x0, sizeof tmp);
		if (real_len < 16) {
			for (i = 0; i < real_len; i++)
		  		tmp[i] = in[aadlen + k + i];
		}
		else {
			for (i = 0; i < 16; i++)
		  		tmp[i] = in[aadlen + k + i];
		}
		
		memset(out_tmp, 0x0, sizeof out_tmp);
		if (do_encrypt)
			SM4_encrypt(tmp, out_tmp, sm4_ctx);
		else
			SM4_decrypt(tmp, out_tmp, sm4_ctx);
		for (i = 0; i < 16; i++)
		  out[header_len + k + i] = out_tmp[i];

		k += 16;
		real_len -= 16;
	} while (real_len > 0);


	return 0;
}
